function* idGenerator() {
  let i = 1;
  while (i < Number.MAX_SAFE_INTEGER) {
    yield i++;
  }
  throw "Cannot generate more ids";
}

export function makeIdGenerator() {
  const gen = idGenerator();
  return () => gen.next().value;
}

export function getQuadFromBBox(bbox = []) {
  if (!bbox || bbox.length !== 4) {
    throw "bbox have to be an array with x1, y1, x2, y2 values";
  }
  const [x1, y1, x2, y2] = bbox;
  return {
    p1: { x: x1, y: y1 },
    p2: { x: x2, y: y1 },
    p3: { x: x2, y: y2 },
    p4: { x: x1, y: y2 }
  };
}

export function capitalCaseFirstLetter(str = "") {
  return str[0].toUpperCase() + str.slice(1);
}
